/* SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-Clause) */
#define TASK_WAKEKILL 0x0100
#define TASK_UNINTERRUPTIBLE 0x0002
#define TASK_KILLABLE (TASK_WAKEKILL | TASK_UNINTERRUPTIBLE)

#define KERN_STACKID_FLAGS (0 | BPF_F_FAST_STACK_CMP)
#define USER_STACKID_FLAGS (0 | BPF_F_FAST_STACK_CMP | BPF_F_USER_STACK)
#define TASK_COMM_LEN 16


struct event
{
	__u32 blocker_pid;
	__u32 blocker_tgid;
	__u32 target_cpu;
	int blocker_ustack_id;
	int blocker_kstack_id;
	__u64 blocker_run_count;
	__u64 delta_ns;
	char blocker_task[TASK_COMM_LEN];
	__u32 waker_pid;
	__u32 waker_tgid;
	__u32 waker_cpu;
	int waker_ustack_id;
	int waker_kstack_id;
	__u64 waker_run_count;
	__u64 waker_runtime;
	char waker_task[TASK_COMM_LEN];
};

struct arg_val
{
	__u64 threshold;
	bool tracestack;
	int tgid;
	char targ_comm[TASK_COMM_LEN];
    __u32 comm_len;
};
