// 注意：TASK_WAKEKILL 状态位的值在 Linux 4.14 内核以后发生了变化
// 默认 BTF 的编译方式在大于等于 Linux 4.14 内核上
#define TASK_WAKEKILL 0x0100
#define TASK_UNINTERRUPTIBLE 0x0002
#define TASK_KILLABLE (TASK_WAKEKILL | TASK_UNINTERRUPTIBLE)

#define MAX_ENTRIES 10240
#define TASK_COMM_LEN 16

struct event {
    __u32 pid;
    __u32 cpu;
    __u32 stack_id;
    char task[TASK_COMM_LEN]; 
    __u32 waker_pid;
    __u32 waker_cpu;
    __u32 waker_stack_id;
    char waker_task[TASK_COMM_LEN];
    __u64 delta_ns;
};

#define KERN_STACKID_FLAGS (0 | BPF_F_FAST_STACK_CMP)
#define USER_STACKID_FLAGS (0 | BPF_F_FAST_STACK_CMP | BPF_F_USER_STACK)

/* the value of the output summary */
struct val_t {
        __u64 ns;
};

// for saving process info
struct task_t {
     __u32 pid;
     char comm[TASK_COMM_LEN];
};
