#define TASK_COMM_LEN 16

struct bpf_arg
{
    bool compare_runtime;
    __u64 min_ns;
    __u64 increase;
    __u32 kernel_version;
    char targ_comm[TASK_COMM_LEN];
    __u32 comm_len;
    int tgid;
    __u32 target_cg;

};

struct task_info
{
    __u64 oncpu_time;
    __u64 utime;
    __u64 stime;
    __u64 sum_exec_runtime;
    int k_stack_id;
    int u_stack_id;
    unsigned long pcount;
    int total_min;
};

struct event
{
    char task[TASK_COMM_LEN];
    __u32 pid;
    __u32 tgid;
    __u32 cpu;
    int k_stack_id;
    int u_stack_id;
    __u64 this_stime;
    __u64 this_utime;
    __u64 this_runtime;
    __u64 exec_time;
    unsigned long pcount;
};

#define KERN_STACKID_FLAGS (0 | BPF_F_FAST_STACK_CMP)
#define USER_STACKID_FLAGS (0 | BPF_F_FAST_STACK_CMP | BPF_F_USER_STACK)
