#define TASK_DEAD  0x0080
#define EXIT_DEAD 0x0010
#define EXIT_ZOMBIE 0x0020
#define TASK_RUNNING 0x0000

#define KERN_STACKID_FLAGS (0 | BPF_F_FAST_STACK_CMP)
#define USER_STACKID_FLAGS (0 | BPF_F_FAST_STACK_CMP | BPF_F_USER_STACK)

#define TASK_COMM_LEN 16
#define MAX_NR 1024
#define PERF_MAX_STACK_DEPTH 127
#define MAX_MATCH_NR 64

struct event
{
        __u32 pid;
        __u32 tgid;
        int u_stack_id;
        int k_stack_id;
        long int sysid;
        long int state;
        __u64 delay, stamp;
        __u64 nvcsw, nivcsw, icnt, vcnt;
        __u64 realtime, stime, itime, vtime;
        char comm[16];
};

struct arg_val
{
        __u32 pid;
        __u32 tid;
        __u64 thresh;
        char targ_comm[TASK_COMM_LEN];
        __u32 comm_len;
        bool filter_sysnr;
        bool filter_cg;
        __u32 target_cg;
        //        struct filter filter;
};
